︠8f1585d8-c4bd-4fac-988b-de8b71df570b︠
reset
︡c1ed2a7e-036e-4f4c-9b24-414435f7dcc2︡{"stdout":"<function reset at 0x7f5cab46af50>"}︡{"stdout":"\n"}︡{"done":true}
︠bc65a71e-fac5-42c0-a965-7490e82fe1c2︠
#Exercise 1:Synthetic division
# Make a function long_div(L, c)  that takes a list L=[a_n,_(n-1),...,a_0] of length n+1 of coefficients of a polynomial p  and a number c and returns the list B  of length n+1. The first  n  elements of B are the coefficients of the quotient (p(x))/(x-c). The last element on the list S is the remainder. Test your function on example of your choice.

#//Input:
#//Output:
def long_div(L, c):
    S=[L[0]]
    for j in range(1,len(L)):
        temp=L[j]+c*L[j-1] #See Lecture 4 for the formula that defines coefficient of the quotient
        S.append(temp)
    return S
L=[3,2,-5,1];# p=3x^3+2x^2-5x+1
long_div(L, 2)
︡112b3778-1663-4af8-a26f-f8df6099a477︡{"stdout":"[3, 8, -1, -9]\n"}︡{"done":true}
︠3939a18f-bfed-47c2-86f8-294445b47965s︠
#Answer: quotient: 3x^2-4x-9; remainder: 11. Check:
simplify(expand((3*x^2+8*x+11)*(x-2)+23))
︡4fa6a317-bb58-416b-bab4-60c544df3943︡{"stdout":"3*x^3 + 2*x^2 - 5*x + 1"}︡{"stdout":"\n"}︡{"done":true}
︠aa8c3751-5d4f-44dc-8f90-0e196099f1e1︠
︡88666c84-559c-4798-b17e-e1d6f5990d49︡
︠735c1b7a-ad85-407b-860e-335a468ede21s︠
#################
#Exercise 2. Finding integer roots of monic polynomials
#(a) Make a function find_int_roots(L) that takes a list L of coefficients of a monic polynomial p with integer constant term and returns the list S  of integer roots of the polynomial. If the polynomial does not have integer roots, the function returns the empty list. Test your function on the polynomial p(x)=x^4+2 x^3-x^2-8 x-12. Find all integer roots.
#Your code will be more readable if you define first a function that evaluates a polynomial
def poly_val(A,c):# See pseudocode in Lecture 1
    n=len(A)
    val=A[0]
    for j in range(1,n):
        val=(val*c+A[j])
    return val

def find_int_roots(L): #L=[1,a_(n-1),...,a_0],a_0 must be an integer
    divs_pos=divisors(L[-1])# L[-1] is the last element on the list
    divs_neg=[-c for c in divs_pos]
    divs=divs_pos + divs_neg
    int_roots=[]
    for c in divs:
        if poly_val(L,c)==0:
            int_roots.append(c)
    return int_roots
︡64817290-58b5-4bc8-a5ec-072b2ae6b3bd︡{"done":true}
︠a39447af-f9b7-4181-b6cc-bf45c8fa7623︠

︡6f9e7736-6039-4c9b-8da6-ef5d2fc8617f︡
︠c40a8dc9-b475-468e-8dc8-323cc40790ebs︠
poly_val([1,2,-1,-8,-12],1)
︡aeddf376-3766-4471-992a-3ea9c048293b︡{"stdout":"-18\n"}︡{"done":true}
︠52ccbd8f-e931-49e9-af17-1afa1f5fe613s︠
L=[1,2,-1,-8,-12];find_int_roots(L)
#Answer to example in (a):integer zeros of p(x)=x^4+2*x^3-x^2-8*x-12 are
︡052ffbab-9d88-4e38-bc24-c010eb9126b8︡{"stdout":"[2, -2]\n"}︡{"done":true}
︠54447d5f-3780-4e34-851c-0513cf67de5as︠
#(b) Use your function constructed in Exercise 1 to find the polynomial p(x)/((x-2)(x+2)).
#I use the function: p(x)=x^4+2 x^3-x^2-8 x-12
L=[1,2,-1,-8,-12]
L1=long_div(L,2);L1
︡f04273a5-9095-40a1-86a9-b4f3b9dc9ee1︡{"stdout":"[1, 4, 3, -10, -28]\n"}︡{"done":true}
︠b2b3fafc-7192-4465-8e7a-86760e2c0749s︠
L2=long_div(L1,-2);L2
#Answer to (b): p(x)/(x^2-4)=?.
︡87c55ce9-6254-4d89-8dec-1a9d1e36e006︡{"stdout":"[1, 2, -5, -16, -8]\n"}︡{"done":true}
︠362317c9-ac9f-4ee7-b6ef-fec2d9ef8958s︠
#Exercise 3 (manual). Describe a set of points in the pq-plane that does not lie on any tangent to the envelope. What does it mean for the corresponding quadratic equations?
#There is no real root? 
#It has infinity quadratic equations
reset
var('t c')
p=x^3+3*x^2-2*x+4
q=p.sub(x=t-c);q
︡8a7bf03a-5006-4c22-a5fc-6bf9aff58f7e︡{"stdout":"<function reset at 0x7fef23eeef50>\n"}︡{"stdout":"(t, c)\n"}︡{"stderr":"Error in lines 4-4\nTraceback (most recent call last):\n  File \"/cocalc/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 1191, in execute\n    flags=compile_flags), namespace, locals)\n  File \"\", line 1, in <module>\n  File \"sage/structure/element.pyx\", line 489, in sage.structure.element.Element.__getattr__ (build/cythonized/sage/structure/element.c:4599)\n    return self.getattr_from_category(name)\n  File \"sage/structure/element.pyx\", line 502, in sage.structure.element.Element.getattr_from_category (build/cythonized/sage/structure/element.c:4708)\n    return getattr_from_other_class(self, cls, name)\n  File \"sage/cpython/getattr.pyx\", line 394, in sage.cpython.getattr.getattr_from_other_class (build/cythonized/sage/cpython/getattr.c:2607)\n    raise AttributeError(dummy_error_message)\nAttributeError: 'sage.symbolic.expression.Expression' object has no attribute 'sub'\n"}︡{"done":true}
︠99e9c30f-f0f8-421a-9a24-527c88f227e8s︠
r=q.expand();r
︡d340dcbc-8feb-4a1c-ae2a-a5869bf28d7e︡{"stderr":"Error in lines 1-1\nTraceback (most recent call last):\n  File \"/cocalc/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 1191, in execute\n    flags=compile_flags), namespace, locals)\n  File \"\", line 1, in <module>\nNameError: name 'q' is not defined\n"}︡{"done":true}
︠443ce3f9-f992-4fe3-a5a7-2f8984020396︠
#########################
︡848d07ed-3190-414a-bc60-041e75ff2964︡
︠a3f3bf89-3061-4a6c-a828-0378850eb9c7︠
##REMARK.
#You can ask SageMath to construct the list of polynomial coefficients using more involved structure called polynomial ring
var('x')
_.<x> = PolynomialRing(RR)#This line says that you will make polynomials with real coefficients in powers of the variable x
p=x^3-2*x^2+3*x-7
L=p.coefficients();L# This command returns the list of coefficients of p
︡05a82437-91a3-4acf-888c-3894a4a0da52︡{"stdout":"x\n"}︡{"stdout":"[-7.00000000000000, 3.00000000000000, -2.00000000000000, 1.00000000000000]\n"}︡{"done":true}
︠48ef1807-b39b-40b6-bb1f-ff324bcae681︠
L.reverse();L# This command reverses the order of the list elements
︡fc76be2a-2ffe-45e8-82b1-61cfa3ebc9ab︡{"stdout":"[1.00000000000000, -2.00000000000000, 3.00000000000000, -7.00000000000000]\n"}︡{"done":true}
︠f557a9f3-6eb8-4cfd-b24c-b179c3078fbb︠
#With these commands you can modify the codes of several exercises in assignments. For example, synthetic_div.
//Input: polynomial q with real coefficients and a real number c
//Output: coefficients (or approximations) of the polynomial q/(x-c) and the remainder
def long_div2(q, c):
    L=q.?();L.reverse()
    S=[L[0]]
    for j in ?:
        temp=?
        S.append(temp)
    return S
synthetic_div2(p,2)
︡2c6eac75-91b5-45e2-ab32-592b5bafba15︡{"stdout":"[1.00000000000000, 0.000000000000000, 3.00000000000000, -1.00000000000000]\n"}︡{"done":true}
︠af7f4f1c-3e77-450e-848f-afed0a75fbc2︠
#Result: (x^3-2*x^2+3*x-7)/(x-2)=x^2+3,remainder -1
#Check (with SageMath "black box" command)
f(x)=x^3-2*x^2+3*x-7
g(x)=x-2
f.maxima_methods().divide(g)

︡19f084a7-edd9-4485-9c7e-46361be136e3︡{"stdout":"[x^2 + 3, -1]\n"}︡{"done":true}
︠09126ae3-ca20-4d99-a91a-75d9e600a3bc︠
#You do not need poly_val function when you work with polynomial instead of the list of its coefficients. Here is p(2):
p.subs(x=2)

︡78a6ffa9-a72c-4408-93e7-20691e1006d1︡{"stdout":"-1.00000000000000\n"}︡{"done":true}
︠cbfc1274-d874-49c3-bdaa-d56fdd09bbd4︠
#########################
︡ea45c7de-8891-426a-8c41-b157e569f9a9︡
︠1e4287dc-d593-41d4-9d5e-c55e7cc482c0s︠
#Exercise 4. Make a function remove_xsquared(L) that takes a polynomial with real coefficients and returns the number c such that substitution x = t-c eliminates the quadratic term in p. Check your code on the polynomial p(x)=x^3+3.5 x^(2)-2.1*x+4.0.
#I experimented with SageMath commands for this task interactively:
var('t c')
q=p.subs(x=t-c);r=q.expand();r.simplify()
︡6ca47540-d755-4560-aee2-c3d7f841b24d︡{"stdout":"(t, c)\n"}︡{"stdout":"-1.0*c^3 + 3.0*c^2*t - 3.0*c*t^2 + 1.0*t^3 - 2.0*c^2 + 4.0*c*t - 2.0*t^2 - 3.0*c + 3.0*t - 7.0\n"}︡{"done":true}
︠0a53de19-e53c-4b11-a3df-1b2d3c052aba︠
r.coefficient(t,n=2)# What does this comman do?
︡76fed478-5e0e-4fc9-9ff9-7fc0b684a219︡{"stdout":"-3.00000000000000*c - 2.00000000000000\n"}︡{"done":true}
︠c599348b-d53d-41d3-a29d-a8ce214884cd︠
c=-2/3;r.subs(c=-2/3)# No term with t^2. It works.
︡63572bc3-36e0-458c-bc0a-54da0bce850c︡{"stdout":"1.00000000000000*t^3 + 1.66666666666667*t - 5.59259259259259\n"}︡{"done":true}
︠18256518-21a8-4f41-a921-ae216daa7f95︠
#Now it is your turn to combine the commands into the function remove_xsquared(q)
#//Input:
#//Output:
def remove_xsquared(q):
    var('t c')
    r=q.subs(x=t-c)
    ...
︡4dcad3e1-c884-4054-a231-fd76ffa359a7︡
︠43d13873-688a-463e-890f-61d52f45e5ef︠
##########################
︡a579f7e1-4069-4727-8fd8-fd8a3f1263cf︡
︠3f282fae-d2b4-48a4-acc9-93f093c6e094s︠
#Exercise 5. Make a function roots_of_unity(n) that takes a natural number n and returns a list of all n^th  roots of unity. Use your function for n = 7  and plot corresponding regular heptagon inscribed into the unit circle. Note that a heptagon is not constructible polygon, that is, it cannot be constructed with compass and straightedge.
#//
#//
def roots_of_unity(n):
    L=[N(cos(2*pi*k/n)+I*sin(2*pi*k/n)) for k in range(n)]#Encode the formula for roots of unity from Lecture 4
    return L
roots_of_unity(7);L
︡2aa00997-2557-4bf1-8558-060ede44d97a︡{"stdout":"[1.00000000000000, 0.623489801858734 + 0.781831482468030*I, -0.222520933956314 + 0.974927912181824*I, -0.900968867902419 + 0.433883739117558*I, -0.900968867902419 - 0.433883739117558*I, -0.222520933956314 - 0.974927912181824*I, 0.623489801858734 - 0.781831482468030*I]\n[1.00000000000000, 0.623489801858734 + 0.781831482468030*I, -0.222520933956314 + 0.974927912181824*I, -0.900968867902419 + 0.433883739117558*I, -0.900968867902419 - 0.433883739117558*I, -0.222520933956314 - 0.974927912181824*I, 0.623489801858734 - 0.781831482468030*I]\n"}︡{"done":true}
︠0b737f0c-a583-4fa9-a365-ebbe30bca316s︠
[(L[j].real(),L[j].imag())for j in range(7)];S
︡714e1678-9f65-40cb-8ffd-ead07cd3eec1︡{"stdout":"[(1.00000000000000, 0), (0.623489801858734, 0.781831482468030), (-0.222520933956314, 0.974927912181824), (-0.900968867902419, 0.433883739117558), (-0.900968867902419, -0.433883739117558), (-0.222520933956314, -0.974927912181824), (0.623489801858734, -0.781831482468030)]\n"}︡{"stderr":"Error in lines 1-1\nTraceback (most recent call last):\n  File \"/cocalc/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 1191, in execute\n    flags=compile_flags), namespace, locals)\n  File \"\", line 1, in <module>\nNameError: name 'S' is not defined\n"}︡{"done":true}
︠377e5b8c-a5f8-4544-8cd2-904ebed9d372s︠
point(S,aspect_ratio=1,size=30)
︡864f5a86-cb2d-4394-bc7c-01bbcad7e85f︡{"stderr":"Error in lines 1-1\nTraceback (most recent call last):\n  File \"/cocalc/lib/python2.7/site-packages/smc_sagews/sage_server.py\", line 1191, in execute\n    flags=compile_flags), namespace, locals)\n  File \"\", line 1, in <module>\nNameError: name 'S' is not defined\n"}︡{"done":true}
︠1817d10e-406d-4184-b478-563ff642676e︠
#Use the function for k=7 and plot the heptagon using the roots of unity to specify the coordinates of the vertices.
︡2bf9d2af-0d1d-42e4-bab9-ac2599577c5d︡{"done":true}
︠42fbc393-1f98-4256-a991-8b909ad8669f︠
############################
︡9aeb1fca-80e0-4a1f-bcb5-c5cf4d011d36︡
︠d58e0159-f3ab-4d17-993f-174eef9d595e︠
#Mini project
#Follow the directions in Lecture 4.
︡8c36d40b-576f-46de-a12b-2992272822a4︡
︠9db8c80a-30af-4047-9b18-c2b9a1522f7f︠

︡c2f94094-c389-4e3d-b146-84af4e227910︡
︠fe5931d4-d765-48a6-acee-0d149dc6e08ds︠
︡931347e0-92d9-4821-b7e6-4dd4644b53f1︡{"done":true}
︠90e1a8ba-6302-4d30-b6a3-f2fb89a468bd︠

︡c58553bb-b3aa-43c7-8bc5-1c1cb6d82a1d︡
︠b3cdc9b6-c80e-4daf-a9af-469bc75a0cec︠

︠6ec9afc3-e934-42bb-89af-d803aa451cef︠

︠27622957-6ee4-4455-9efe-9a2c71996845︠










